/*--------------------------------------------------------------------------*/
/*                              PROTO   TYPES                               */
/*--------------------------------------------------------------------------*/
void          init_menu(void);
void          display_menu(void);
void          pls(int,int,unsigned char[],int);
void          frect(int,int,int,int,int,int);
void          dl_rect(int,int,int,int,int);
void          rect(int,int,int,int,int);
int           menus(char [20][40],int,int,int,int,int,int);
void          writechar(int,int,unsigned char,int);
void          initdisplay(void);
int           getkey(void);
int           messagebox(int,int,int,int,int,int,int,int);
void          chcolor(int,int,int,int,int);
void          init_mouse(void);
void          show_mouse_cursor(void);
void          hide_mouse_cursor(void);
void          get_mouse_location(void);
int           mouse_left_pressed(void);
int           mouse_state(void);
int           bar_menu(int);
int           alt_pressed(void);
void          txt_curs(int);
void          cls(void);
unsigned char seperate(char *,char *,int *,int *,int);
int           expand(int);
void          place_title_hot(int);
int           submenu(long,int,int);
int           remove_spaces(char *);
void          bg_menu_color(int color);
void          fg_menu_color(int color);
void          bg_menu_hotkey_color(int);
void          fg_menu_hotkey_color(int);
void          bg_menu_sel_color(int);
void          fg_menu_sel_color(int);
void          bg_menu_shadow(int);
void          fg_menu_shadow(int);
void          ch_menu_x(int);
void          ch_menu_y(int);
void          ch_menu_xsize(int);
void          ch_menu_filename(char *);
int           next_line(char *,int);
void          set_pos(long *);
long          get_pos(void);
void          set_menu_descriptor(int, char **,int); 
void          frect_char(unsigned char) ;
unsigned char readchar(int,int);
int           readcolor(int,int);
int           displayfield(struct field *field,int);
void          readstring(int,int,int,char *);
int           set_video_mode(int);
int           get_video_mode(void);
void          gcurs(int);
/*--------------------------------------------------------------------------*/
/*                               STRUCTURES                                 */
/*--------------------------------------------------------------------------*/
struct field          
{ int  x;                  /* field's X coordinate              */
  int  y;                  /* field's Y coordinate              */
  int  length;             /* field length                      */
  char title[20];          /* title of the field                */
  char f[80];              /* field content                     */
  int  fcolor;             /* field color                       */
  int  tcolor;             /* title color                       */
  int  xstart;             /* default x location for the cursor */
                           /* as character #,  first char=0     */
};
/*--------------------------------------------------------------------------*/
/*                               DEFINITIONS                                */
/*--------------------------------------------------------------------------*/
#define TEXT_FILE    0
#define VARIABLE     1

#define OFF          0
#define ON           1

#define YES          1
#define NO           0


#define BS 				8
#define FORMFEED 		12
#define CR 				13
#define ENTER        13
#define ESC 			27
#define HOMEKEY 		327
#define ENDKEY 		335
#define UPKEY 			328
#define DOWNKEY 		336
#define PGUPKEY 		329
#define PGDNKEY 		337
#define LEFTKEY 		331
#define INSKEY 		338
#define RIGHTKEY 		333
#define DELKEY 		339
#define CTRLLEFTKEY 	371
#define CTRLRIGHTKEY 372
#define TAB          9
#define SHIFTTAB     271
#define SPACE        32
#define BLOCK1       176
#define BLOCK2       177
#define BLOCK3       178

#define F1 				315
#define F2 				316
#define F3  			317
#define F4  			318
#define F5  			319
#define F6  			320
#define F7  			321
#define F8  			322
#define F9  			323
#define F10  			324

/*--------------------------------------------*/
/*                  COLORS                    */
/*--------------------------------------------*/
#define BK_BLACK           0x00
#define BK_BLUE            0x10
#define BK_GREEN           0x20
#define BK_CYAN            0x30
#define BK_RED             0x40
#define BK_MAGENTA         0x50
#define BK_BROWN           0x60
#define BK_WHITE           0x70
                           

#define FG_BLACK           0x00
#define FG_BLUE            0x01
#define FG_GREEN           0x02
#define FG_CYAN            0x03
#define FG_RED             0x04
#define FG_MAGENTA         0x05
#define FG_BROWN           0x06
#define FG_WHITE           0x07
#define FG_GRAY            0x08
#define FG_LIGHT_BLUE      0x09
#define FG_LIGHT_GREEN     0x0A
#define FG_LIGHT_CYAN      0x0B
#define FG_LIGHT_RED       0x0C
#define FG_LIGHT_MAGENTA   0x0D
#define FG_LIGHT_YELLOW    0x0E
#define FG_BRIGHT_WHITE    0x0F
/*--------------------------------------------*/


#define PRESSED           0
#define RELEASED          1
#define PRESSEDRELEASED   2

#define INIT              0
#define KEY_RETURN        1
#define DISPLAY           2
#define EDIT              3


#define BLOCK             2
#define SQUARE            3
#define LINE              4
#define POSITION          5
#define GETPOSITION       6

#define MAX_TITLE 10
#define MAX_ENTRIES 20

#define MAX_ACC 100              /* maximum allowed accelerateors         */

#define MAX_WINDOWS 10            /* maximum level of sub menus allowed    */

/*--------------------------------------------------------------------------*/
/*                          GLOBAL     VARIABLES                            */
/*--------------------------------------------------------------------------*/
extern  int   mousefound;
extern  int   mousex;
extern  int   mousey;

extern  int   txt_curs_x;
extern  int   txt_curs_y;
extern  int   ms;

extern  unsigned char  back_block;

extern char menu_file[40];
extern int  menu_color;
extern int  menu_hotkey_color;
extern int  menu_sel_color;
extern int  menu_shadow;
extern int  menu_x;                  
extern int  menu_y;
extern int  menu_x_size;           


extern int font_width;
extern int font_height;
extern int gr_scr_xsize;
extern int gr_scr_ysize;
extern int txt_scr_xsize;
extern int txt_scr_ysize;

extern char menu_title[MAX_TITLE][20];    
extern char title_hotkey[MAX_TITLE];
extern char title_hotkey_loc[MAX_TITLE];
extern long title_loc [MAX_TITLE];        
extern int  title_ident[MAX_TITLE];
extern int  title_acc[MAX_TITLE];
extern int  title_x[MAX_TITLE];
extern int  title_num;                 
extern int  title_ptr;
extern int  box_num;

extern int num_of_lines;

